//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property indicator_separate_window
#property  indicator_buffers 7
#property indicator_color1 Green
#property indicator_color2 LimeGreen
#property indicator_color3 PaleVioletRed
#property indicator_color4 HotPink
#property indicator_color5 Silver
#property indicator_color6 Silver
#property indicator_color7 Silver
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2

//
//
//
//
//

extern string ForSymbol       = "";
extern double PaCycles        = 1.0;
extern double PaFilter        = 1.0;
extern int    LwmaPrice       = PRICE_CLOSE;
extern int    EmaPeriod       = 10;
extern bool   Invert          = false;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

double slope[];
double ema1[];
double ema2[];
double slopeuu[];
double slopeud[];
double slopedu[];
double slopedd[];
double trend[];
string indicatorFileName;
bool   returnBars;
bool   calculateValue;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{      
   IndicatorDigits(6);    
   IndicatorBuffers(8);    
   SetIndexBuffer(0,slopeud); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,slopeuu); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,slopedd); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,slopedu); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,slope);
   SetIndexBuffer(5,ema1);
   SetIndexBuffer(6,ema2);
   SetIndexBuffer(7,trend);
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = ForSymbol=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = ForSymbol=="returnBars";     if (returnBars)     { return(0); }
      
      //
      //
      //
      //
      //
      
      if (ForSymbol=="") ForSymbol=Symbol();
      IndicatorShortName(ForSymbol+" Slope ("+DoubleToStr(PaCycles,2)+")");
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit=MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { slopeud[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || ForSymbol==Symbol())
   {
      double multiplier = 1; if (Invert) multiplier = -1;
      double alpha = 2.0/(1.0+EmaPeriod);
      for (int i=limit; i>=0; i--)
      {
         double price      =  iMA(NULL,0,1,0,MODE_SMA,LwmaPrice,i);
         int    LwmaPeriod = MathMax(iHilbertPhase(price,PaFilter,PaCycles,i),2);

            //
            //
            //
            //
            //
            
            if (Bars-i<=LwmaPeriod)
            {
               slope[i] = 0; 
               ema1[i]  = 0; 
               ema2[i]  = 0; 
               continue;
            }            
         
            //
            //
            //
            //
            //
            //
            
            slope[i] = multiplier*(iMA(NULL,0,LwmaPeriod+1,0,MODE_LWMA,LwmaPrice,i)-calcWhatever(LwmaPeriod,i));
            if (EmaPeriod>0)
            {
               if (slope[i]>0)
                     ema1[i] = ema1[i+1]+alpha*(slope[i]-ema1[i+1]);
               else  ema1[i] = ema1[i+1];
               if (slope[i]<0)
                     ema2[i] = ema2[i+1]+alpha*(slope[i]-ema2[i+1]);
               else  ema2[i] = ema2[i+1];
            }
            else { ema1[i] = 0; ema2[i] = 0; }
         
         //
         //
         //
         //
         //

         trend[i] = trend[i+1];         
            if (slope[i]>0) trend[i] =  1;
            if (slope[i]<0) trend[i] = -1;
         slopeuu[i] = EMPTY_VALUE;
         slopeud[i] = EMPTY_VALUE;
         slopedd[i] = EMPTY_VALUE;
         slopedu[i] = EMPTY_VALUE;
            if (slope[i]>ema1[i]) { slopeuu[i] = slope[i]; continue; }
            if (slope[i]>0)       { slopeud[i] = slope[i]; continue; }
            if (slope[i]<ema2[i]) { slopedu[i] = slope[i]; continue; }
            if (slope[i]<0)       { slopedd[i] = slope[i]; continue; }
      }
      manageAlerts();
      return( 0 );
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(ForSymbol,0,indicatorFileName,"returnBars",0,0)));
   for(i = limit; i >= 0; i--)
   {
      int y = iBarShift(ForSymbol,0,Time[i]);
         slope[i]   = iCustom(ForSymbol,0,indicatorFileName,"calculateValue",PaCycles,PaFilter,LwmaPrice,EmaPeriod,Invert,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,4,y);
         ema1[i]    = iCustom(ForSymbol,0,indicatorFileName,"calculateValue",PaCycles,PaFilter,LwmaPrice,EmaPeriod,Invert,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,5,y);
         ema2[i]    = iCustom(ForSymbol,0,indicatorFileName,"calculateValue",PaCycles,PaFilter,LwmaPrice,EmaPeriod,Invert,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,6,y);
         slopeuu[i] = EMPTY_VALUE;
         slopeud[i] = EMPTY_VALUE;
         slopedd[i] = EMPTY_VALUE;
         slopedu[i] = EMPTY_VALUE;
            if (slope[i]>ema1[i]) { slopeuu[i] = slope[i]; continue; }
            if (slope[i]>0)       { slopeud[i] = slope[i]; continue; }
            if (slope[i]<ema2[i]) { slopedu[i] = slope[i]; continue; }
            if (slope[i]<0)       { slopedd[i] = slope[i]; continue; }
   }         
   return(0);         
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double calcWhatever( int period, int i)
{
   double Sum  = (period+1)*iMA(NULL,0,1,0,MODE_SMA,LwmaPrice,i+1)+period*iMA(NULL,0,1,0,MODE_SMA,LwmaPrice,i);
   double Sumw = (period+1)+period;
   int j,k;

      //
      //
      //
      //
      //
      
      for (j=1, k=period; j <= period; j++,k-- )
      {
         Sum  += k*iMA(NULL,0,1,0,MODE_SMA,LwmaPrice,i+j+1);
         Sumw += k;
      }

   return( Sum / Sumw );
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workHil[][9];
#define _price      0
#define _smooth     1
#define _detrender  2
#define _period     3
#define _instPeriod 4
#define _phase      5
#define _deltaPhase 6
#define _Q1         7
#define _I1         8

#define Pi 3.14159265358979323846264338327950288

//
//
//
//
//

double iHilbertPhase(double price, double filter, double cyclesToReach, int i, int s=0)
{
   if (ArrayRange(workHil,0)!=Bars) ArrayResize(workHil,Bars);
   int r = Bars-i-1; s = s*9;
      
   //
   //
   //
   //
   //
      
      workHil[r][s+_price]      = price;
      workHil[r][s+_smooth]     = (4.0*workHil[r][s+_price]+3.0*workHil[r-1][s+_price]+2.0*workHil[r-2][s+_price]+workHil[r-3][s+_price])/10.0;
      workHil[r][s+_detrender]  = calcComp(r,_smooth,s);
      workHil[r][s+_Q1]         = 0.15*calcComp(r,_detrender,s)  +0.85*workHil[r-1][s+_Q1];
      workHil[r][s+_I1]         = 0.15*workHil[r-3][s+_detrender]+0.85*workHil[r-1][s+_I1];
      workHil[r][s+_phase]      = workHil[r-1][s+_phase];
      workHil[r][s+_instPeriod] = workHil[r-1][s+_instPeriod];

      //
      //
      //
      //
      //
           
         if (MathAbs(workHil[r][s+_I1])>0)
                     workHil[r][s+_phase] = 180.0/Pi*MathArctan(MathAbs(workHil[r][s+_Q1]/workHil[r][s+_I1]));
           
         if (workHil[r][s+_I1]<0 && workHil[r][s+_Q1]>0) workHil[r][s+_phase] = 180-workHil[r][s+_phase];
         if (workHil[r][s+_I1]<0 && workHil[r][s+_Q1]<0) workHil[r][s+_phase] = 180+workHil[r][s+_phase];
         if (workHil[r][s+_I1]>0 && workHil[r][s+_Q1]<0) workHil[r][s+_phase] = 360-workHil[r][s+_phase];

      //
      //
      //
      //
      //
                        
      workHil[r][s+_deltaPhase] = workHil[r-1][s+_phase]-workHil[r][s+_phase];

         if (workHil[r-1][s+_phase]<90 && workHil[r][s+_phase]>270)
             workHil[r][s+_deltaPhase] = 360+workHil[r-1][s+_phase]-workHil[r][s+_phase];
             workHil[r][s+_deltaPhase] = MathMax(MathMin(workHil[r][s+_deltaPhase],60),7);
      
            //
            //
            //
            //
            //
                  
            double alpha    = 2.0/(1.0+MathMax(filter,1));
            double phaseSum = 0; for (int k=0; phaseSum<cyclesToReach*360 && (r-k)>0; k++) phaseSum += workHil[r-k][s+_deltaPhase];
         
            if (k>0) workHil[r][s+_instPeriod]= k;
                    workHil[r][s+_period] = workHil[r-1][s+_period]+alpha*(workHil[r][s+_instPeriod]-workHil[r-1][s+_period]);
            return (workHil[r][s+_period]);
}

//
//
//
//
//

double calcComp(int r, int from, int s)
{
   return((0.0962*workHil[r  ][s+from] + 
           0.5769*workHil[r-2][s+from] - 
           0.5769*workHil[r-4][s+from] - 
           0.0962*workHil[r-6][s+from]) * (0.075*workHil[r-1][s+_period] + 0.54));
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  ForSymbol+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" trend changed to "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(Symbol()+" slope ",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

